// The Auto Braille Commander
// compiled with BCPP 4.51, using -mc switch for compact memory model
/*
 Communicates with ABRL.COM, the AutoBraille TSR
 Copyright (C) 1995 KANSYS, Inc.
 This program is free software; you can redistribute it and/or 
 modify it under the terms of the GNU General Public License as 
 published by the Free Software Foundation; either version 2 of 
 the License, or (at your option) any later version.
 This program is distributed in the hope that it will be useful, 
 but WITHOUT ANY WARRANTY; without even the implied warranty of 
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU 
 General Public License for more details.
 You should have received a copy of the GNU General Public License 
 along with this program; if not, write to the Free Software 
 Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 Author: Charles E. Hallenbeck, Ph.D.
 KanSys, Inc.
 4301 Wimbledon Terr. #2B
 Lawrence, KS 66047
 Telephone: 913-843-0351
*/
#define SYSNUM 241
#define SN SYSNUM*256
#define VERSION 8
#define MSG "not recognized"
#include <stdio.h>
#include <conio.h>
#include <ctype.h>
#include <stdLIB.h>
#include <string.h>
#include <bios.h>
#include <dos.h>
#include <dir.h>
char *hotkey(int, int);
void getstatus(int);
void put1status(char *, int);
void put2status(char *);
void setscreen(void);
main (int argc, char **argv)
{ unsigned a, c1, c2;
char b[80], *b1, fn[MAXPATH];
if (_osmajor<3) { puts("Requires DOS 3.0 or later"); exit(1); }
strcpy(fn, *argv);
_AX=SN+0; geninterrupt(47); a=_AL;
if (a!=255)
{ puts ("\n*** AutoBraille is not presently installed ***"); exit(1); }
_AX=SN+100; geninterrupt(47); a=_AL;
if (a!=VERSION)
{ puts ("\n*** Incorrect AutoBraille version ***"); exit(1); }
if (argc==1) { puts("\n AutoBraille Commander V1.5\n");
puts("Usage: ABC command command command ...\n Commands are:");
puts("STATUS -- Report current settings and selections");
puts("SAVE RESTORE -- Save or Restore current settings and selections");
puts("RESET -- Return to original settings and selections");
puts("WINDOWS -- Locate text input and braille output on screen");
puts("IN=LPT1 IN=LPT2 IN=LPT3 -- Accept input from this parallel port");
puts("OUT=LPT1 OUT=LPT2 OUT=LPT3 OUT=COM1 OUT=COM2 -- Send output to this port");
puts("LPT1 LPT2 LPT3 SCREEN -- Use for both input and output\n");
puts("PORT=110E7 ... PORT=9600E7 -- Baud rate, Even parity, 7 data bits");
puts("PORT=110N8 ... PORT=9600N8 -- Baud rate, No parity, 8 data bits");
puts("(Baud rates: 110, 150, 300, 600, 1200, 2400, 4800, 9600)\n");
puts("FORMFEED=YES FORMFEED=NO -- Use formfeed between pages");
puts("FILLING=YES FILLINGG=NO -- Form into paragraphs by filling lines");
puts("CLEARFIELD=YES CLEARFIELD=NO -- Screen outside braille window");
puts("WATCHDOG=YES WATCHDOG=NO -- Monitor activity with speaker buzz");
puts("ABSWITCH=A ABSWITCH=B -- Activate or Bypass AutoBraille");
puts ("GRADE=1 GRADE=2 GRADE=3 -- Braille Translation Level");
printf ("\n More..."); getche(); system ("cls");
puts("\n The following Turbo Braille Dot Commands are also recognized:\n");
puts(".BL#,# -- Bottom Line, each # = 0 ... 3");
puts(".TL#,# -- Top Line, each # = 0 ... 3");
puts(".DV#,# -- Divider, each # = 0 ... PL");
puts(".PL# -- Page Length, # = 1 ...");
puts(".PO# -- Page Offset, # = 0 ... RM");
puts(".RM# -- Right Margin, # = 1 ...");
puts("\".RH text string\" -- Running Header"); }
while (--argc) { strcpy (b, *++argv); strlwr(b);
if (!strcmp(b, "reset"))
{ _AX=SN+1; geninterrupt(47); continue; }
if (!strcmp(b, "status")) { getstatus(SN+2); continue; }
if (!strcmp(b, "save")) { put1status(fn, SN+2); continue; }
if (!strcmp(b, "restore")) { put2status(fn); continue; }
if (!strcmp(b, "windows") || !strcmp(b, "window")
 || !strcmp(b, "hotkeys") || !strcmp(b, "hotkey"))
{ setscreen(); continue; }
if (!strcmp(b, "in=lpt1") || !strcmp(b, "in=lpt1:")
 || !strcmp(b, "in=lpt") || !strcmp(b, "in=lpt:")
 || !strcmp(b, "in=prn") || !strcmp(b, "in=prn:"))
{ _AX=SN+4; geninterrupt(47); continue; }
if (!strcmp(b, "in=lpt2") || !strcmp(b, "in=lpt2:"))
{ _AX=SN+5; geninterrupt(47); continue; }
if (!strcmp(b, "in=lpt3") || !strcmp(b, "in=lpt3:"))
{ _AX=SN+6; geninterrupt(47); continue; }
if (!strcmp(b, "out=lpt1") || !strcmp(b, "out=lpt1:")
 || !strcmp(b, "out=lpt") || !strcmp(b, "out=lpt:")
 || !strcmp(b, "out=prn") || !strcmp(b, "out=prn:"))
{ _AX=SN+9; geninterrupt(47); continue; }
if (!strcmp(b, "out=lpt2") || !strcmp(b, "out=lpt2:"))
{ _AX=SN+10; geninterrupt(47); continue; }
if (!strcmp(b, "out=lpt3") || !strcmp(b, "out=lpt3:"))
{ _AX=SN+11; geninterrupt(47); continue; }
if (!strcmp(b, "out=none") || !strcmp(b, "out=null")
 || !strcmp(b, "out=nul") || !strcmp(b, "out=sink"))
{ _AX=SN+12; geninterrupt(47); continue; }
if (!strcmp(b, "out=com1") || !strcmp(b, "out=com1:")
 || !strcmp(b, "out=com") || !strcmp(b, "out=com:")
 || !strcmp(b, "out=aux") || !strcmp(b, "out=aux:")
 || !strcmp(b, "com1") || !strcmp(b, "com1:") || !strcmp(b, "com")
 || !strcmp(b, "com:") || !strcmp(b, "aux") || !strcmp(b, "aux:"))
{ _AX=SN+14; geninterrupt(47); continue; }
if (!strcmp(b, "out=com2") || !strcmp(b, "out=com2:")
 || !strcmp(b, "com2") || !strcmp(b, "com2:"))
{ _AX=SN+15; geninterrupt(47); continue; }
if (!strcmp(b, "none") || !strcmp(b, "nul") || !strcmp(b, "null"))
{ _AX=SN+7; geninterrupt(47);
_AX=SN+12; geninterrupt(47); continue; }
if (!strcmp(b, "screen") || !strcmp(b, "video")
 || !strcmp(b, "crt") || !strcmp(b, "crt:"))
{ _AX=SN+7; geninterrupt(47);
_AX=SN+13; geninterrupt(47); continue; }
if (!strcmp(b, "lpt1") || !strcmp(b, "lpt1:") || !strcmp(b, "lpt")
 || !strcmp(b, "lpt:") || !strcmp(b, "prn") || !strcmp(b, "prn:"))
{ _AX=SN+4; geninterrupt(47);
_AX=SN+9; geninterrupt(47); continue; }
if (!strcmp(b, "lpt2") || !strcmp(b, "lpt2:"))
{ _AX=SN+5; geninterrupt(47);
_AX=SN+10; geninterrupt(47); continue; }
if (!strcmp(b, "lpt3") || !strcmp(b, "lpt3:"))
{ _AX=SN+6; geninterrupt(47);
_AX=SN+11; geninterrupt(47); continue; }
if (!strcmp(b, "port=110e7"))
{ _AX=SN+16; geninterrupt(47); continue; }
if (!strcmp(b, "port=110n8"))
{ _AX=SN+17; geninterrupt(47); continue; }
if (!strcmp(b, "port=150e7"))
{ _AX=SN+18; geninterrupt(47); continue; }
if (!strcmp(b, "port=150n8"))
{ _AX=SN+19; geninterrupt(47); continue; }
if (!strcmp(b, "port=300e7"))
{ _AX=SN+20; geninterrupt(47); continue; }
if (!strcmp(b, "port=300n8"))
{ _AX=SN+21; geninterrupt(47); continue; }
if (!strcmp(b, "port=600e7"))
{ _AX=SN+22; geninterrupt(47); continue; }
if (!strcmp(b, "port=600n8"))
{ _AX=SN+23; geninterrupt(47); continue; }
if (!strcmp(b, "port=1200e7"))
{ _AX=SN+24; geninterrupt(47); continue; }
if (!strcmp(b, "port=1200n8"))
{ _AX=SN+25; geninterrupt(47); continue; }
if (!strcmp(b, "port=2400e7"))
{ _AX=SN+26; geninterrupt(47); continue; }
if (!strcmp(b, "port=2400n8"))
{ _AX=SN+27; geninterrupt(47); continue; }
if (!strcmp(b, "port=4800e7"))
{ _AX=SN+28; geninterrupt(47); continue; }
if (!strcmp(b, "port=4800n8"))
{ _AX=SN+29; geninterrupt(47); continue; }
if (!strcmp(b, "port=9600e7"))
{ _AX=SN+30; geninterrupt(47); continue; }
if (!strcmp(b, "port=9600n8"))
{ _AX=SN+31; geninterrupt(47); continue; }
if (!strcmp(b, "grade=1"))
{ _AX=SN+34; _BX=1; geninterrupt(47); continue; }
if (!strcmp(b, "grade=2"))
{ _AX=SN+34; _BX=2; geninterrupt(47); continue; }
if (!strcmp(b, "grade=3"))
{ _AX=SN+34; _BX=3; geninterrupt(47); continue; }
if (!strcmp(b, "formfeed=yes"))
{ _AX=SN+32; _BX=1; geninterrupt(47); continue; }
if (!strcmp(b, "formfeed=no"))
{ _AX=SN+33; _BX=1; geninterrupt(47); continue; }
if (!strcmp(b, "filling=yes"))
{ _AX=SN+32; _BX=2; geninterrupt(47); continue; }
if (!strcmp(b, "filling=no"))
{ _AX=SN+33; _BX=2; geninterrupt(47); continue; }
if (!strcmp(b, "clearfield=yes"))
{ _AX=SN+32; _BX=4; geninterrupt(47); continue; }
if (!strcmp(b, "clearfield=no"))
{ _AX=SN+33; _BX=4; geninterrupt(47); continue; }
if (!strcmp(b, "watchdog=yes"))
{ _AX=SN+32; _BX=8; geninterrupt(47); continue; }
if (!strcmp(b, "watchdog=no"))
{ _AX=SN+33; _BX=8; geninterrupt(47); continue; }
if (!strcmp(b, "abswitch=a"))
{ _AX=SN+32; _BX=16; geninterrupt(47); continue; }
if (!strcmp(b, "abswitch=b"))
{ _AX=SN+33; _BX=16; geninterrupt(47); continue; }
if (*b=='.') { /* process dot command */
if (b[1]=='b' && b[2]=='l') { c1=c2=0; a=SN+50;
sscanf(b+3, "%d,%d", &c1, &c2);
_BH=c1; _BL=c2; _AX=a; geninterrupt(47); }
else if (b[1]=='t' && b[2]=='l') { c1=c2=0; a=SN+51;
sscanf(b+3, "%d,%d", &c1, &c2);
_BH=c1; _BL=c2; _AX=a; geninterrupt(47); }
else if (b[1]=='d' && b[2]=='v') { c1=c2=0; a=SN+52;
sscanf(b+3, "%d,%d", &c1, &c2);
_BH=c1; _BL=c2; _AX=a; geninterrupt(47); }
else if (b[1]=='p' && b[2]=='l') { c1=0; a=SN+53;
sscanf(b+3, "%d", &c1);
_BX=c1; _AX=a; geninterrupt(47); }
else if (b[1]=='p' && b[2]=='o') { c1=0; a=SN+54;
sscanf(b+3, "%d", &c1);
_BX=c1; _AX=a; geninterrupt(47); }
else if (b[1]=='r' && b[2]=='h') { a=SN+40;
b1=*argv; b1+=3; while (*b1==' ') b1++;
do { c1=*b1; _BX=c1; _AX=a; geninterrupt(47); a=SN+41; }
while (*b1++); }
else if (b[1]=='r' && b[2]=='m') { c1=0; a=SN+55;
sscanf(b+3, "%d", &c1);
_BX=c1; _AX=a; geninterrupt(47); }
else printf("Dot command '%s' is not recognized\n", b); }
else printf("Command '%s' is not recognized\n", b); } return(0); }
/***/void getstatus(int n)
{ static int a0, a1, a2;
static unsigned hk;
_AX=n; geninterrupt(47); a1=_AL; n++;
printf("AutoBraille status: FreeWare copy using %s memory\n",
(a1? "expanded": "conventional"));
_AX=n; geninterrupt(47); a0=_AX; a1=a0%256; a2=a0/256;
if (a1>2) printf ("In=Screen ");
else printf("In=Lpt%d ", a1+1); switch (a2) { /* output target */
case 0: case 1: case 2: printf("Out=Lpt%d ", a2+1); break;
case 3: printf("Out=Null "); break;
case 4: printf("Out=Screen "); break;
case 5: case 6: printf("Out=Com%d ", a2-4); break; }
_AX=n; geninterrupt(47); a1=_AX;
if (a2>4) { printf("Port=");
switch (a1%256) { /* baud, parity, data bits */
case 3: printf("110N8"); break;
case 26: printf("110E7"); break;
case 35: printf("150N8"); break;
case 58: printf("150E7"); break;
case 67: printf("300N8"); break;
case 90: printf("300E7"); break;
case 99: printf("600N8"); break;
case 122: printf("600E7"); break;
case 131: printf("1200N8"); break;
case 154: printf("1200E7"); break;
case 163: printf("2400N8"); break;
case 186: printf("2400E7"); break;
case 195: printf("4800N8"); break;
case 218: printf("4800E7"); break;
case 227: printf("9600N8"); break;
case 250: printf("9600E7"); break;
default: printf("invalid"); break; } }
printf ("\nFormfeed=%s Filling=%s Clearfield=%s\nWatchdog=%s ABSwitch=%s\n",
(a1&256? "yes": "no"), (a1&512? "yes": "no"),
(a1&1024? "yes": "no"), (a1&2048? "yes": "no"),
(a1&4096? "A: activate": "B: bypass"));
_AX=n; geninterrupt(47); a1=_AX; _AX=n; geninterrupt(47); a2=_AX;
printf("Text window: columns %d-%d, lines %d-%d;\n",
a1%256, a2%256, a1/256, a2/256);
_AX=n; geninterrupt(47); a1=_AX; _AX=n; geninterrupt(47); a2=_AX;
printf("Braille window: columns %d-%d, lines %d-%d;\n",
a1%256, a2%256, a1/256, a2/256);
_AX=n; geninterrupt(47); hk=_AX; /* hot key #1 */
printf("Hot key #1: %s (char %d, scan %d) Text Window;\n",
hotkey(hk%256, hk/256), hk%256, hk/256);
_AX=n; geninterrupt(47); hk=_AX; /* hot key #2 */
printf("Hot key #2: %s (char %d, scan %d) Snapshot;\n",
hotkey(hk%256, hk/256), hk%256, hk/256);
_AX=n; geninterrupt(47); hk=_AX; /* hot key #3 */
printf("Hot key #3: %s (char %d, scan %d) ABSwitch;\n",
hotkey(hk%256, hk/256), hk%256, hk/256);
_AX=n; geninterrupt(47); a1=_AX;
printf("Dot commands: .BL%d,%d ", a1/256, a1%256);
_AX=n; geninterrupt(47); a1=_AX;
printf(".TL%d,%d ", a1/256, a1%256);
_AX=n; geninterrupt(47); a1=_AX;
printf(".DV%d,%d ", a1/256, a1%256);
_AX=n; geninterrupt(47); a1=_AX;
printf(".PL%d .PO%d ", a1%256, a1/256);
_AX=n; geninterrupt(47); a1=_AX;
printf(".RM%d ", a1%256);
_AX=n; geninterrupt(47); a0=_AX; /* .gr */
for (a1=0; a1<20; a1++) { _AX=n; geninterrupt(47); a2=_AX;
if (!a1) printf("\n\".RH ");
if (a2%256) printf("%c", a2%256); else break;
if (a2/256) printf("%c", a2/256); else break; } puts("\"");
printf ("Braille translation level is grade %d.\n", a0); }
/***/void put1status(char *fn, int n) {
static int a, a1, a2;
static long c1;
static FILE *fp;
fp=fopen(fn, "rb+");
a=getc(fp); a=getc(fp); a=getc(fp); a+=(256*getc(fp));
c1=getc(fp); c1+=(256*getc(fp))-1; c1*=512; c1+=a;
fseek(fp, c1, 0);
_AX=n; geninterrupt(47); n++; /* skip first word */
for (a=0; a<15; a++) { _AX=n; geninterrupt(47); a1=_AX;
putc(a1%256, fp); putc(a1/256, fp); }
for (a1=0; a1<20; a1++) { _AX=n; geninterrupt(47); a2=_AX;
if (a2%256) putc(a2%256, fp); else break;
if (a2/256) putc(a2/256, fp); else break; } putc(0, fp);
fclose(fp); }
/***/void put2status(char *fn) {
static int a, a1, a2, b;
static long c1;
static FILE *fp;
fp=fopen(fn, "rb");
a=getc(fp); a=getc(fp); a=getc(fp); a+=(256*getc(fp));
c1=getc(fp); c1+=(256*getc(fp))-1; c1*=512; c1+=a;
fseek(fp, c1, 0);
if ((a=getc(fp))==EOF)
{ _AX=SN+1; geninterrupt(47); return; /* reset */ }
_AX=SN+a+4; geninterrupt(47); /* in= */
a=getc(fp); _AX=SN+a+9; geninterrupt(47); /* out= */
a=getc(fp); switch (a) { /* baud, parity, data bits */
case 3: a1=17; break; case 26: a1=16; break;
case 35: a1=19; break; case 58: a1=18; break;
case 67: a1=21; break; case 90: a1=20; break;
case 99: a1=23; break; case 122: a1=22; break;
case 131: a1=25; break; case 154: a1=24; break;
case 163: a1=27; break; case 186: a1=26; break;
case 195: a1=29; break; case 218: a1=28; break;
case 250: a1=30; break; default: a1=31; break; }
_AX=SN+a1; geninterrupt(47);
a=getc(fp); /* states */
a1=(a&1? 32: 33); _AX=SN+a1; _BX=1; geninterrupt(47);
a1=(a&2? 32: 33); _AX=SN+a1; _BX=2; geninterrupt(47);
a1=(a&4? 32: 33); _AX=SN+a1; _BX=4; geninterrupt(47);
a1=(a&8? 32: 33); _AX=SN+a1; _BX=8; geninterrupt(47);
a1=(a&16? 32: 33); _AX=SN+a1; _BX=16; geninterrupt(47);
a=SN+43; a1=getc(fp); a2=getc(fp); /* tw1 */
_BL=a1; _BH=a2; _AX=a; geninterrupt(47);
a=SN+44; a1=getc(fp); a2=getc(fp); /* tw2 */
_BL=a1; _BH=a2; _AX=a; geninterrupt(47);
a=SN+45; a1=getc(fp); a2=getc(fp); /* bw1 */
_BL=a1; _BH=a2; _AX=a; geninterrupt(47);
a=SN+46; a1=getc(fp); a2=getc(fp); /* bw2 */
_BL=a1; _BH=a2; _AX=a; geninterrupt(47);
a=SN+47; a1=getc(fp); a2=getc(fp); /* hk1 */
_BL=a1; _BH=a2; _AX=a; geninterrupt(47);
a=SN+48; a1=getc(fp); a2=getc(fp); /* hk2 */
_BL=a1; _BH=a2; _AX=a; geninterrupt(47);
a=SN+49; a1=getc(fp); a2=getc(fp); /* hk3 */
_BL=a1; _BH=a2; _AX=a; geninterrupt(47);
a=SN+50; a1=getc(fp); a2=getc(fp); /* .bl */
_BL=a1; _BH=a2; _AX=a; geninterrupt(47);
a=SN+51; a1=getc(fp); a2=getc(fp); /* .tl */
_BL=a1; _BH=a2; _AX=a; geninterrupt(47);
a=SN+52; a1=getc(fp); a2=getc(fp); /* .dv */
_BL=a1; _BH=a2; _AX=a; geninterrupt(47);
a=SN+53; a1=getc(fp); /* .pl */
_BX=a1; _AX=a; geninterrupt(47);
a=SN+54; a1=getc(fp); /* .po */
_BX=a1; _AX=a; geninterrupt(47);
a=SN+55; a1=getc(fp); /* .rm */
_BX=a1; _AX=a; geninterrupt(47);
a=getc(fp); /* skip left margin */
a=SN+34; a1=getc(fp); /* grade */
_BX=a1; _AX=a; geninterrupt(47);
a=getc(fp); /* skip extra byte */
a=SN+40; do { if ((b=getc(fp))<32) break;
_BX=b; _AX=a; geninterrupt(47); a=SN+41; } while (b);
fclose(fp); }
/***/void setscreen(void) {
static unsigned a, k, s, hk1, hk2, hk3, hk4, hk5, hk6;
static int tw1, tw2, tw3, tw4, bw1, bw2, bw3, bw4;
char *b, c[40];
_AX=SN+2; geninterrupt(47); _AX=SN+3; geninterrupt(47);
_AX=SN+3; geninterrupt(47); /* skip first three words */
_AX=SN+3; geninterrupt(47); a=_AX; tw1=a%256; tw2=a/256;
_AX=SN+3; geninterrupt(47); a=_AX; tw3=a%256; tw4=a/256;
_AX=SN+3; geninterrupt(47); a=_AX; bw1=a%256; bw2=a/256;
_AX=SN+3; geninterrupt(47); a=_AX; bw3=a%256; bw4=a/256;
_AX=SN+3; geninterrupt(47); a=_AX; hk1=a%256; hk2=a/256;
_AX=SN+3; geninterrupt(47); a=_AX; hk3=a%256; hk4=a/256;
_AX=SN+3; geninterrupt(47); a=_AX; hk5=a%256; hk6=a/256;
puts("Define text input window, braille output window, and hot keys.");
do { printf("\n T Text, B Braille, H Hot keys, D Done: ");
k=getch(); if (!isspace(k)) printf("%c\n", k); k=tolower(k);
if (k=='t') { printf("Left edge (%d): ", tw1); gets(c);
a=0; sscanf(c, "%d", &a); if (a<81 && a>0) tw1=a;
printf("Right edge (%d): ", tw3); gets(c);
a=0; sscanf(c, "%d", &a); if (a<81 && a>(tw1-1)) tw3=a;
printf("Top edge (%d): ", tw2); gets(c);
a=0; sscanf(c, "%d", &a); if (a<26 && a>0) tw2=a;
printf("Bottom edge (%d): ", tw4); gets(c);
a=0; sscanf(c, "%d", &a); if (a<26 && a>(tw2-1)) tw4=a;
printf("\n Setting text columns %d-%d, lines %d-%d.\n", tw1, tw3, tw2, tw4);
_BL=tw1; _BH=tw2; _AX=SN+43; geninterrupt(47);
_BL=tw3; _BH=tw4; _AX=SN+44; geninterrupt(47); }
else if (k=='b') { printf("Left edge (%d): ", bw1); gets(c);
a=0; sscanf(c, "%d", &a); if (a<81 && a>0) bw1=a;
printf("Right edge (%d): ", bw3); gets(c);
a=0; sscanf(c, "%d", &a); if (a<81 && a>(bw1-1)) bw3=a;
printf("Top edge (%d): ", bw2); gets(c);
a=0; sscanf(c, "%d", &a); if (a<26 && a>0) bw2=a;
printf("Bottom edge (%d): ", bw4); gets(c);
a=0; sscanf(c, "%d", &a); if (a<26 && a>(bw2-1)) bw4=a;
printf("\n Setting braille columns %d-%d, lines %d-%d.\n", bw1, bw3, bw2, bw4);
_BL=bw1; _BH=bw2; _AX=SN+45; geninterrupt(47);
_BL=bw3; _BH=bw4; _AX=SN+46; geninterrupt(47); }
else if (k=='h') { printf("Hot key #1: %s; Translates the text window;\n",
hotkey(hk1, hk2)); printf("New Hotkey #1 selection: ");
a=bioskey(0); s=a/256; a%=256; putchar('\n');
if (!isspace(a)) { b=hotkey(a, s); printf("%s\n", b);
if ((a==hk3 && s==hk4) || (a==hk5 && s==hk6)) puts("Key already in use!");
else { if (strcmp(b, MSG)) { hk1=a; hk2=s; }
printf("Setting hot key #1 to %s (char %d, scan %d).\n",
hotkey(hk1, hk2), hk1, hk2);
_BL=hk1; _BH=hk2; _AX=SN+47; geninterrupt(47); } }
printf("Hot key #2: %s; Snapshot of screen text and attributes;\n",
hotkey(hk3, hk4)); printf("New Hotkey #2 selection: ");
a=bioskey(0); s=a/256; a%=256; putchar('\n');
if (!isspace(a)) { b=hotkey(a, s); printf("%s\n", b);
if ((a==hk1 && s==hk2) || (a==hk5 && s==hk6)) puts("Key already in use!");
else { if (strcmp(b, MSG)) { hk3=a; hk4=s; }
printf("Setting hot key #2 to %s (char %d, scan %d).\n",
hotkey(hk3, hk4), hk3, hk4);
_BL=hk3; _BH=hk4; _AX=SN+48; geninterrupt(47); } }
printf("Hot key #3: %s; AutoBraille printer ABSwitch;\n",
hotkey(hk5, hk6)); printf("New Hotkey #3 selection: ");
a=bioskey(0); s=a/256; a%=256; putchar('\n');
if (!isspace(a)) { b=hotkey(a, s); printf("%s\n", b);
if ((a==hk1 && s==hk2) || (a==hk3 && s==hk4)) puts("Key already in use!");
else { if (strcmp(b, MSG)) { hk5=a; hk6=s; }
printf("Setting hot key #3 to %s (char %d, scan %d).\n",
hotkey(hk5, hk6), hk5, hk6);
_BL=hk5; _BH=hk6; _AX=SN+49; geninterrupt(47); } } }
} while (k!='d'); }
/***/char *hotkey(int a, int s) {
static struct st { int a, s; char *n; }
hk[]={ 1, 30, "Control A", 0, 30, "Alt A",
2, 48, "Control B", 0, 48, "Alt B",
3, 46, "Control C", 0, 46, "Alt C",
4, 32, "Control D", 0, 32, "Alt D",
5, 18, "Control E", 0, 18, "Alt E",
6, 33, "Control F", 0, 33, "Alt F",
7, 34, "Control G", 0, 34, "Alt G",
8, 35, "Control H", 0, 35, "Alt H",
9, 23, "Control I", 0, 23, "Alt I",
10, 36, "Control J", 0, 36, "Alt J",
11, 37, "Control K", 0, 37, "Alt K",
12, 38, "Control L", 0, 38, "Alt L",
13, 50, "Control M", 0, 50, "Alt M",
14, 49, "Control N", 0, 49, "Alt N",
15, 24, "Control O", 0, 24, "Alt O",
15, 25, "Control P", 0, 25, "Alt P",
17, 16, "Control Q", 0, 16, "Alt Q",
18, 19, "Control R", 0, 19, "Alt R",
19, 31, "Control S", 0, 31, "Alt S",
20, 20, "Control T", 0, 20, "Alt T",
21, 22, "Control U", 0, 22, "Alt U",
22, 47, "Control V", 0, 47, "Alt V",
23, 17, "Control W", 0, 17, "Alt W",
24, 45, "Control X", 0, 45, "Alt X",
25, 21, "Control Y", 0, 21, "Alt Y",
26, 44, "Control Z", 0, 44, "Alt Z",
27, 26, "Control [", 28, 43, "Control \\",
29, 27, "Control ]", 30, 7, "Control ^",
31, 12, "Control _", 0, 131, "Alt =",
127, 14, "Control BSP", 0, 130, "Alt _",
0, 120, "Alt 1", 0, 121, "Alt 2", 0, 122, "Alt 3",
0, 123, "Alt 4", 0, 124, "Alt 5", 0, 125, "Alt 6",
0, 126, "Alt 7", 0, 127, "Alt 8", 0, 128, "Alt 9",
0, 129, "Alt 0",
0, 59, "F1", 0, 60, "F2", 0, 61, "F3", 0, 62, "F4",
0, 63, "F5", 0, 64, "F6", 0, 65, "F7", 0, 66, "F8",
0, 67, "F9", 0, 68, "F10", 0, 84, "Shift F1", 0, 85, "Shift F2",
0, 86, "Shift F3", 0, 87, "Shift F4", 0, 88, "Shift F5",
0, 89, "Shift F6", 0, 90, "Shift F7", 0, 91, "Shift F8",
0, 92, "Shift F9", 0, 93, "Shift F10", 0, 94, "Control F1",
0, 95, "Control F2", 0, 96, "Control F3", 0, 97, "Control F4",
0, 98, "Control F5", 0, 99, "Control F6", 0, 100, "Control F7",
0, 101, "Control F8", 0, 102, "Control F9", 0, 103, "Control F10",
0, 104, "Alt F1", 0, 105, "Alt F2", 0, 106, "Alt F3",
0, 107, "Alt F4", 0, 108, "Alt F5", 0, 109, "Alt F6",
0, 110, "Alt F7", 0, 111, "Alt F8", 0, 112, "Alt F9",
0, 113, "Alt F10" };
static int b, nhk=sizeof(hk) / sizeof(struct st);
for (b=0; b<nhk; b++) if (a==hk[b].a && s==hk[b].s) return (hk[b].n);
return (MSG); }

